#include <stdio.h>
#include <stdlib.h>
#include <string> 
#include <iostream>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>
#include "connectbase.h"
#include <strstream>
#define MAX 64


string listeParam; 
string paramPlus[MAX];
string paramMoins[MAX];
int resppage = 15;
ConnectBase base;

void ExtraireListe (const string & ligne, string & arg){
  int pos = 0;
  /* Recherche du signe '=', puis extraction jusqu''&' */
  while (ligne[pos++] != '=');
  arg = ligne.substr(pos);
}


string ExtraireParam (const string & ligne, string & arg ,char sep){
  int pos = 0, posArg=0;
  /* Recherche du signe '+', puis extraction jusqu''&' */
  while ( pos < ligne.size() &&  ligne[pos] != sep)
      arg += ligne[pos++];
      //arg[posArg] = '\0';
  if(pos<ligne.size())
    return ligne.substr(pos+1);
  return "";
}


string verifier(string mot){
  string result;
  int fin[2];
  int fout[2];
  
  pipe( fin );
  pipe( fout );
  
  // Sauve
  int oldRead = dup( 0 );
  int oldWrite = dup( 1 );
  
  dup2( fin[0], 0 );
  dup2( fout[1], 1 );
  
  write(fin[1],mot.c_str(),mot.length());
  write(fin[1],"\n",1);

  close(fin[1]);
  system("aspell -a");

  close( fout[1]);
 
  dup2( oldRead, 0 );
  dup2( oldWrite, 1 );

  char motr[255];

  int nbCaracLu = read( fout[0], motr, 254 );
  while( nbCaracLu ) {
    motr[ nbCaracLu ] = '\0';
    result += motr;
    nbCaracLu = read( fout[0], motr, 254 );
  }
  return result;
}


void requete(int nbPlus,int nbMoins,int deb,int fi){
  int nbParamPlus = nbPlus;
  int nbParamMoins = nbMoins;
  string limit = ";";
  if (deb != fi){
    strstream lim;
    lim << "LIMIT " << deb << " , "  << fi << ";" << ends;
    limit = lim.str();
  }
  //creation d'une table temporaire
  string req1; 
  string req2;
  if (nbParamMoins > 0) {
    string milreq1;
    string debreq1 = "create table tmp select C.idUrl from CorrespMotUrl C, MotCle M where C.idMot=M.idMot and M.mot in ";
    string fin =" group by (C.idUrl);";
    milreq1 = "(";
    for(int t = 0;t < nbParamMoins;t++){
      milreq1 += "'"; 
      milreq1 += paramMoins[t];
      milreq1 += "'";
      if (t != nbParamMoins - 1 ) milreq1 += ",";
    }
    milreq1 += ")";
    req1 = debreq1 + milreq1 + fin;
    //cout << req1 << "<BR>"  << endl; 
  }

  if((nbParamPlus > 0) && (nbParamMoins > 0) ){
    string milreq2;
    string debreq2 = "select U.url, sum(C.ratio) as ratio , count(M.mot) as nb from Url U, CorrespMotUrl C, MotCle M left join tmp T on C.idUrl=T.idUrl where (T.idUrl is NULL) and C.idUrl=U.idUrl and C.idMot=M.idMot and M.mot in ";
    string fin =" group by (U.url) order by nb desc, ratio desc, U.nbMotsTheme desc ";
    milreq2 = "(";
    for(int t = 0;t < nbParamPlus;t++){
      milreq2 += "'"; 
      milreq2 += paramPlus[t];
      milreq2 += "'";
      if (t != nbParamPlus - 1 ) milreq2 += ",";
    }
    milreq2 += ")";
    req2 = debreq2 + milreq2 + fin + limit;
    //cout << req2 << "<BR>" << endl;
    base.executeQuery(req1);
    base.executeSelect(req2);
  } else if ((nbParamPlus > 1) && (nbParamMoins == 0) ){
    string milreq2;
    string debreq2 = "select U.url, sum(C.ratio) as ratio , count(M.mot) as nb from Url U, CorrespMotUrl C, MotCle M where C.idUrl=U.idUrl and C.idMot=M.idMot and M.mot in ";
    string fin =" group by (U.url) having nb > 1 order by nb desc, ratio desc, U.nbMotsTheme desc ";
    milreq2 = "(";
    for(int t = 0;t < nbParamPlus;t++){
      milreq2 += "'"; 
      milreq2 += paramPlus[t];
      milreq2 += "'";
      if (t != nbParamPlus - 1 ) milreq2 += ",";
    }
    milreq2 += ")";
    req2 = debreq2 + milreq2 + fin + limit;
   // cout << req2 << "<BR>" << endl;
    base.executeSelect(req2);
  } else if ((nbParamPlus == 1) && (nbParamMoins == 0) ){
    string milreq2;
    string debreq2 = "select U.url, C.ratio from Url U, CorrespMotUrl C, MotCle M where  M.mot in ('";
    string fin ="') and C.idMot=M.idMot and C.idUrl=U.idUrl  order by C.ratio, U.nbMotsTheme desc ";
    milreq2 = paramPlus[0];
    req2 = debreq2 + milreq2 + fin + limit;
   //cout << req2 << "<BR>" << endl;
    base.executeSelect(req2);
  } else {
   cout << "Erreur de paramtres" << "<BR>"  << endl;
  }
}


int main(int argc, char **argv, char **env) {
  string ligne;
  string ligne1;
  string ligne2;
  int nbPlus;
  int nbMoins;
  int i = 0;
  int j = 0; 
  bool verif = 0;

  //on efface la table temporaire
  //string req3 = "drop table tmp;";
  string req4 = "drop table if exists tmp;";
  base.executeQuery(req4); 
  
  //Entte HTML
  
  cout << "Content-Type: text/html" << endl << endl;
  cout << "<HTML><HEAD><TITLE>Moteur de recherche</TITLE></HEAD><BODY>" << endl;
  
  //ligne de commande
  ligne = getenv("QUERY_STRING");
  string cmd = getenv("SERVER_NAME");
  //cout << cmd << endl;
  string cmd2 = getenv("SCRIPT_NAME");
  //cout << cmd2 << endl;

  ligne = ExtraireParam(ligne,ligne1,'&');
  ligne = ExtraireParam(ligne,ligne2,'&');
  
  
  if(!ligne.empty()){verif = true;}
  string numPage;
  ExtraireListe(ligne2,numPage);
  
  int nPage = atoi(numPage.c_str());
  
  //cout << "page " << nPage << endl;
  
  ExtraireListe(ligne1,listeParam);
  string listeParamf = listeParam;
  string paramTemp = "";
  while(!listeParam.empty()){
    //cout << listeParam << endl;
    listeParam = ExtraireParam(listeParam,paramTemp,'+');
    if(paramTemp[0] == '-'){
      paramMoins[i++] = paramTemp.substr(1);
    } else {
      paramPlus[j++] = paramTemp;
      //cout << paramPlus[j-1] << endl;
    }
      paramTemp = "";
  }
  
  nbPlus = j;
  nbMoins = i;
  //Recuperation des parametres
  int k = 0;
  string temp;
  while(k < nbPlus){
   // cout << "<B>Paramtres Plus "<< k <<" :</B>" <<paramPlus[k] << "<P>\n" << endl;
    if(verif){
      cout << "<B>Corrections possibles" <<" :</B><P>\n"; 
      cout << ExtraireParam(verifier(paramPlus[k]),temp,':') << "<BR>" << endl;
    }
    k++;
    cout << "<BR>" << endl;
  }
  k = 0;
  while(k < nbMoins){
    //cout << "<B>Paramtres Moins "<< k <<" :</B>" <<paramMoins[k] << "<P>\n";
    if(verif){
      cout << "<B>Corrections possibles" <<" :</B><P>\n";
      cout << ExtraireParam(verifier(paramMoins[k]),temp,':') << "<BR>" << endl;
    }
    k++;
    cout << "<BR>" << endl;  
  }

  
  //requete HTML 
  requete(nbPlus,nbMoins,0,0);
  base.executeQuery(req4);
  int nbEntreesTot;
  nbEntreesTot = base.nbEntrees();
  
  int deb = resppage*(nPage-1);
  int fin = resppage*nPage;
  requete(nbPlus,nbMoins,deb,fin);
  //int nbEntrees = 0;
  //nbEntrees = base.nbEntrees();
  string result;
  cout << "<B>" <<"Nombre de pages trouves : " <<nbEntreesTot << "</B>"  << "<BR><BR><BR>" << endl;
  //cout << "<B>" <<"fin  : " << fin << "</B>"  << "<BR><BR><BR>" << endl;
  cout << "<CENTER>" << endl;
  for(int k = 0 ; k < resppage ;k++){
    result = base.donneUrl();
    cout << "<A HREF=\"" << result << "\">" << result <<"</A>" << "<BR><BR>" <<endl;
  }
  //if (nbMoins > 0) base.executeQuery(req3);
  cout << "</CENTER>" << endl;
  cout << "<BR><BR><BR>" << endl;
  strstream ln ;
  strstream lp ;
  ln << "http://" << cmd << ":8080" << cmd2 << "?" << "keyword=" << listeParamf << "&page=" << (nPage+1) << ends;
  lp << "http://" << cmd << ":8080" << cmd2 << "?" << "keyword=" << listeParamf << "&page=" << (nPage-1) << ends;
  string lienNext = ln.str();
  string lienPrev = lp.str();
  if (verif) lienNext+="&verif=Verifier+l%27ortographe";
  if (verif) lienPrev+="&verif=Verifier+l%27ortographe";
  cout << "<CENTER>" << endl;
  
  if (nPage > 1)
    cout << "<a href=" << "\""  << lienPrev << "\"" << ">Previous" << "</a>" << endl;
  
  cout << "&nbsp&nbsp&nbsp&nbsp&nbsp" << endl;
  if (fin < nbEntreesTot )
    cout << "<a href=" << "\""  << lienNext << "\"" << ">Next" << "</a>" << endl;
  cout << "</CENTER>" << endl;
  
  //Fin HTML
  cout << "</BODY></HTML>\n" <<endl;
  base.executeQuery(req4); 
  
} 


//c++  -I/u/org/bds/sengine/mysql++-1.7.9/sqlplusint -I/u/org/bds/sengine/mysql-3.23.49a-pc-linux-gnu-i686/include -g -c script2.c


//c++ -L/u/org/bds/sengine/mysql-3.23.49a-pc-linux-gnu-i686/lib -o script.cgi *.o /u/org/bds/sengine/mysql++-1.7.9/sqlplusint/.libs/libsqlplus.a -L/u/org/bds/sengine/mysql-3.23.49a-pc-linux-gnu-i686/include -lz -lmysqlclient -lz -lmysqlclient -Wl,--rpath -Wl,/usr/local/libc



//Requetes SQL


// avec les mots 'ma et 'le' mais pas le mot 'si'

// create table tmp select C.idUrl from CorrespMotUrl C, MotCle M where C.idMot=M.idMot and M.mot in ('si') group by (C.idUrl) ;

//select U.url, sum(C.ratio) as ratio , count(M.mot) as nb from Url U, CorrespMotUrl C, MotCle M left join tmp T on C.idUrl=T.idUrl  where (T.idUrl is NULL) and C.idUrl=U.idUrl and C.idMot=M.idMot and M.mot in ('ma', 'le') group by (U.url) having nb > 1  order by nb desc, ratio desc;

//drop table tmp; 

// LIMIT 5 , 10

//&verif=Verifier+l%27ortographe
