#include "contraintes.h"

string Contraintes::getDomaine(string url){
  unsigned int i =0;
  url=url.substr(7,url.length()-7);
  while(i<url.length()&&url[i++]!='/');
  if(i==url.length()&&url[i-1]!='/'){
  //cout <<"Domaine"<<url.substr(0,i)<<endl;
    return url.substr(0,i);
    }
//cout <<"Domaine"<<url.substr(0,i-1)<<endl;
  return url.substr(0,i-1);
}

string Contraintes::getChemin(string url){
  unsigned int i =0;
  url=url.substr(7,url.length()-7);
  while(i<url.length()&&url[i++]!='/');
  if (i==url.length()){
       //cout <<"chemin"<<endl;
    return "";
    }
    //cout <<"chemin"<<url.substr(i,url.length()-i)<<endl;
  return url.substr(i,url.length()-i);
}

bool Contraintes::isInDomaine(string url){
  string domaineUrl=getDomaine(url);
  
  int iUrl=domaineUrl.length()-1;
  int iRes=domaine.length()-1;
  while(iRes>=0&& iUrl>=0 && domaine[iRes]==domaineUrl[iUrl]){
    iRes--;
    iUrl--;
  };
   if(domaine==""||(iRes<0 && domaine[iRes+1]==domaineUrl[iUrl+1]&&(iUrl<0||domaineUrl[iUrl]=='.'||domaineUrl[iUrl]=='/'))){
    string cheminUrl=getChemin(url);
    unsigned int i=0;
    while(i<chemin.length()&& i<cheminUrl.length() && chemin[i]==cheminUrl[i]){
	cout<<(chemin[i]==cheminUrl[i]);
      i++;
      }
    if((chemin=="")||(i==chemin.length() && chemin[i-1]==cheminUrl[i-1]&&(i==cheminUrl.length()||cheminUrl[i-1]=='/'))){
  //cout<<"true"<<endl;
      return true;
     }
  }
  //cout<<"false"<<endl;
  return false;
}

bool Contraintes::pageAcceptable(const string & page){
  istrstream flux ( page.c_str(), page.length() );
  string mot="";
  flux >> mot;
  flux >> mot;
  if(mot=="200"||mot=="302"){//type correcte et traite
  	if(mot=="302"){
  		return true;
  	}
    while( flux.good()&&lowerCase(mot)!= "content-type:")
      flux >> mot;
    flux >>mot;
    int taille=mot.length();    		
    if(mot[--taille]!=';')
    		taille++;
    while(--taille>=0&&mot[taille]!='/');
    string type=mot.substr(taille+1,mot.length()-taille-1);
    return typeAcceptable(type);
  }else{//type incorrecte
    return false;
  }
}


int Contraintes::getTimeOut(){
  return timeout;
}

int Contraintes::wordValue(string mot){
  ConstraintWord::iterator i= theme.find(mot);
  if (i==theme.end())
    return 0;
  return i->second;
}

void Contraintes::addMapOfTheme( map<string,unsigned> & motsTheme){
  theme.insert(motsTheme.begin(),motsTheme.end());
}

void Contraintes::addWordOfTheme(string mot, unsigned occurenceMin){
  theme.insert(make_pair(mot,occurenceMin));
}

bool Contraintes::typeAcceptable(string & type){
  ListeTheme::iterator i = find( extension.begin(),extension.end(),type);
  if (i==extension.end())
    return false;
  return true;
}

int Contraintes::getProfondeur(){
  return  profondeurMaxOfSearch;
}
void Contraintes::addTypeOfExtension(string & typeExt){
  extension.push_back(typeExt);
}

void Contraintes::addListOfExtension(list<string> & listExtension){
  ListeTheme copyList(listExtension.size());
  copy(listExtension.begin(),listExtension.end(),copyList.begin());
  while(copyList.begin()!=copyList.end()){
    extension.push_front(copyList.front());
    copyList.pop_front();
  }
}

list<string> Contraintes::getType(){
  return extension;
}

map<string,unsigned> Contraintes::getTheme(){
  return theme;
}

void  Contraintes::affichelist(){
  for(ListeTheme::iterator i=extension.begin();i!=extension.end();i++)
    cout << (*i) <<endl;
}
void  Contraintes::affichemap(){ 
  for(ConstraintWord::iterator i=theme.begin();i!=theme.end();i++)
    cout << (*i).first <<" "<<(*i).second<<endl;
}










//a laisser !!
/*
void main(){
Contraintes cont = Contraintes();
if (cont.isInDomaine("http://www.essi.fr"))
cout<<"ok1"<<endl<<endl;
if (cont.isInDomaine("http://www/index.htm"))
cout<<"ok2"<<endl<<endl;
if (cont.isInDomaine("http://www/loi/moi.inde"))
cout<<"ok3"<<endl<<endl;
if (cont.isInDomaine("http://wwww"))
cout<<"ok4"<<endl<<endl;
}
*/
