/***************************************************************************
                          indexing.h  -  description
                             -------------------
    begin                : Wed May 22 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#ifndef _INDEXING_H_
#define _INDEXING_H_

#include <map>
#include <string>

#include "connectbase.h"
#include "contraintes.h"


class Indexing {
public:
	class InfoWord {
	public:
		unsigned frequence;
		
		InfoWord() : frequence( 0 ) {}
		
	};

	Indexing();
	~Indexing();
	
	void index( const char * fileName, const char * extFile, const string & text, unsigned int & nbWordInTheme,  Contraintes & );

private:
	static ConnectBase dataBase;
	typedef map<string, InfoWord>Dictionary;
	Dictionary listKeyWords;
	
	static string & lowerCase( string & );
				
};

#endif // _INDEXING_H_
