/***************************************************************************
                          parseps.cpp  -  description
                             -------------------
    begin                : Sat Jun 8 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI2 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#include <iostream>
#include <unistd.h>
#include <stdlib.h>
#include <string>
#include <fstream>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>


#include "parseps.h"


ParsePS::ParsePS( const string & text ) {
	char fileIn[20] = "zparsepsXXXXXX";
	char fileOut[20] = "zparsepsXXXXXX";
	mkstemp( fileIn );
	mkstemp( fileOut );

	ofstream out( fileIn, ofstream::binary|ofstream::trunc|ofstream::out );
	out.write( text.data(), text.size() );
	out.close();
	
	string cmd = string( "ps2ascii " ) + fileIn + "  " + fileOut;
	system( cmd.c_str() );
	
	ifstream in( fileOut );
	while( in.good() )
		textMots += in.get();	
		
	in.close();
	
	unlink( fileIn );
	unlink( fileOut );

}


	
const string & ParsePS::getMots() const {
	return textMots;
}
