/***************************************************************************
                          thread.h  -  description
                             -------------------
    begin                : Fri May 24 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#ifndef _THREAD_H_
#define _THREAD_H_

#include <pthread.h>


class Thread {
private:
	pthread_t thread;
	bool running;
	
	static void * startRoutine( void * );
	
public: 
	Thread();
	virtual ~Thread();
	
	void start();
	void stop();
	
	void join();
	
	bool isRunning() const;
	
	void wait();
	void notify();
	
protected:
	virtual void run() = 0;
	
};

#endif // _THREAD_H_
