
#include "traitedoc.h"


TraiteDoc::TraiteDoc(string & urlFic, string & texte):text(texte),nbMotTheme(0),urlFile(urlFic),redirection(false){
   cout <<"z";
	text=lowerCase(text);
	cout<<"a";
  decomposeURL(urlFic);
  cout<<"b";
  infoType();
  cout<<"c";
  traiterPage();
}

TraiteDoc::TraiteDoc(string & urlFic, string & texte,Contraintes & con):text(texte),nbMotTheme(0),urlFile(urlFic),redirection(false),contrainte(con){
  decomposeURL(urlFic);
  infoType();
  traiterPage();
}

vector<string> &TraiteDoc::getLink(){
  return lien;
}

unsigned int TraiteDoc::wordInTheme(){
  return nbMotTheme;
}


void TraiteDoc::decomposeURL(string & url){
  unsigned int taille=url.length();
  while(--taille>=0&&url[taille]!='/');
  unsigned int pas=0;
  while(pas<taille&& url[pas]==' ')
    pas++;
  cheminFic=url.substr(pas,taille-pas+1);
}

void TraiteDoc::infoType(){
  istrstream flux ( text.c_str(), text.length() );
  string mot="";
  flux >> mot;
  flux >> mot;
  if(mot=="200"||mot=="302"){//type correcte et traite
    if(mot=="302"){//une redirection
      	while( flux.good()&&lowerCase(mot)!="location:")
				flux >> mot;
			while( flux.good()&&lowerCase(mot)=="location:"){
				flux >> mot;
				cout<<"y";
			}
   	   lien.push_back(cheminFic+mot);
      	redirection=true;
   	}else{
    		while( flux.good()&&lowerCase(mot)!= "content-type:")
      		flux >> mot;
    		flux >>mot;
    		int taille=mot.length();
    		if(mot[--taille]!=';')
    		taille++;
    		while(--taille>=0&&mot[taille]!='/');
    		extFic=mot.substr(taille+1,mot.length()-taille-1);
    		extFic=lowerCase(extFic);
    	}
  	}else{//type incorrecte
    	extFic="bad";
  }
}

string TraiteDoc::liftingLien(string url){
  //combien de ../ ou ./ il y a?
  int nbDecalage=0; 
  //passage 1 nb de decalage
  int inc=0;
  bool fini=false;
  while(!fini){
  if(url.substr(inc,3)=="../"){
    nbDecalage++;
    inc+=3;
  }
  if(url.substr(inc,2)=="./")
    inc+=2;
  if(url[inc]!='.')
    fini=true;
  }
  //suppression des decalages
  int dec=cheminFic.length();
  while(--nbDecalage>=0){
    while(--dec>=0&&cheminFic[dec]=='/');
    while(--dec>=0&&cheminFic[dec]!='/');
  }
  return cheminFic.substr(0,dec)+'/'+url.substr(inc,url.length()-inc);
}


void TraiteDoc::correctionLiens(){
  int vectsize =lien.size();
  vector<string>::iterator it=lien.begin();
  for(int i=0;i<vectsize;i++){
    string link=lien[i];
    int taille=link.size();
    //suppression des \n et \t
     int pas =0;
     string mot="";
    while(pas<taille){
      if (link[pas]=='\n'||link[pas]=='\t'){
	  pas++;
      }else{
	mot=mot+link[pas++];
      }
    }
    link=mot;
    //suppression des espaces de fin
    while(taille>0 && link[--taille]==' ');
    link=link.substr(0,taille+1);
    //verification que ce n'est pas un lien interne a une page
    while(--taille>=0 && link[taille]!='/'){
    		if(link[taille]=='#'){
      		lien.erase(it);
      		vectsize--;
      		i--;
      		it--;
      	}
     }
 	  if(link[taille]!='#'){
 	      pas=0;
   	   taille=link.size();
     		//suppresion des espaces inutiles devant
     		while(pas<taille && link[pas]==' ')
				pas++;
      	//chemin relatif
      	if(link[pas]=='/'){
      		if(link[pas+1]=='/'){
      			lien[i]="http:"+link.substr(pas,taille-pas);
      		}else{
  					lien[i]=cheminFic+link.substr(pas+1,taille-pas-1);	
  				}
      	}else{
				//chemin absolu accepter
				if(link.substr(pas,7)=="http://" ||link.substr(pas,6)=="file:/"){
	  				lien[i]=link.substr(pas,taille-pas);
				}else{
	  				//chemin absolu incomplet
	  				if(link.substr(pas,4)=="www"){
	    				lien[i]="http://"+link.substr(pas,taille-pas);	
	  				}else{
	    				///ceux que l'on ne veux pas	
	    				if(link.substr(pas,8)=="https://"||link.substr(pas,6)=="ftp://"||link.substr(pas,7)=="mailto:"|| link.substr(pas,11)=="javascript:"){
	      				lien.erase(it);
	      				vectsize--;
	      				i--;
	      				it--;
	    				}else{	
	      				//c'est un repertoire a  echelon ex:../ ou ./
	      				if(link[pas]=='.'){
								lien[i]=liftingLien(link.substr(pas,taille-pas));
	      				}else{
								//il est correcte mais en relatif sans le '/'
								lien[i]=cheminFic+link.substr(pas,taille-pas);	
	      				}
	    				}
	  				}
				}
      	}
    	}
    	it++;
  	}
}

bool TraiteDoc::traiterPage(){
	cout<<"0";
  if (!contrainte.isInDomaine(urlFile))//on regarde suivant la contrainte impose par le domaine
    return false;
    cout<<"1";
  if (redirection){//on a une redirection
  		cout<<"2";
		correctionLiens();
		cout <<"3";
    	return true;
    }
    cout<<"4";
 if((extFic=="html")/*&&contrainte.typeAcceptable(extFic)*/){//on regarde s'il y a une contrainte dans les extensions et le type du lien
 cout<<"5";
    ParseHTML parse(text);	
    cout<<"6";
    lien = parse.getLiens();
    cout<<"7";	
    index.index( cheminFic.c_str(), "html", parse.getMots(),nbMotTheme);
    cout<<"8";  
    if(parse.getBase()!="")
      cheminFic=parse.getBase();
    correctionLiens();
  	 cout<<"9";
  	 return true;
  }else
  	 cout <<"10";
    return false;
}



/*
void main(){
  string typer="htm";
  Contraintes cont =Contraintes();
   cont.addWordOfTheme("poire",1);
   cont.addWordOfTheme("pomme",2);
   cont.addWordOfTheme("peche",1);
   cont.addTypeOfExtension(typer);
  
   string s="http://www.code.bidon/toto1/toto2/lurlabsolu.htm";
   string t="toto bla bla tom pomme poire tre gdh jy fraise e loire";
   string m="http://www.voila.fr/#toto";
   string m0="./.././toto.html";
   string m1="mailto:ki.voici.fr";
   string m2="http://www.gn\nu.org";
   string m5="javascript://super.htm";
   string m4="    http://www.yahoo.fr    ";
   string m3="www";
   string m6="#dddxlo.htm";
   string file="HTTP/1.1 200 Bad Request
 Date: Wed, 29 May 2002 16:21:56 GMT
 Server: Apache/1.3.20 (Unix)
 Connection: close
 Transfer-Encoding: chunked
 Content-Type: text/html; charset=iso-8859-1 

145 
 <!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">
 <HTML><HEAD>
 <TITLE>400 Bad Request</TITLE>
 </HEAD><BODY>
 <H1>Bad Request</H1>
 Your browser sent a request that this server could not understand.<P>
 Invalid URI in request GET : HTTP/1.1<P>
 <HR>
 <ADDRESS>Apache/1.3.20 Server at www.voila.fr Port 80</ADDRESS>
 </BODY></HTML>";
  
   TraiteDoc v = TraiteDoc(s,file,cont);
   v.infoType();
   v.addLien(m);
   v.addLien(m0);
   v.addLien(m1);
   v.addLien(m2);
   v.addLien(m3);
   v.addLien(m4);
   v.addLien(m5); 
   v.addLien(m6);
   cout <<"avant"<<endl;
   v.showLien();
   cout <<endl;
   v.correctionLiens();
   cout <<endl<<"apres"<<endl;
   v.showLien(); 
} 

*/
