#ifndef URLINFO_H
#define URLINFO_H

#include <string>


class UrlInfo
{
public:
	UrlInfo() {}
  UrlInfo(string u, int p) : url(u), priority(p) {}
  UrlInfo(const UrlInfo& u) : url(u.getUrl()), priority(u.getPriority()) {}

  string getUrl() const { return url; }

  int getPriority() const { return priority; }

  void setPriority(int p){ priority=p; }

  bool operator< (const UrlInfo& b) const
  {
    if (this->getPriority() < b.getPriority())
      return true;

    return false;
  }

  string url;
  int priority;

};

#endif
