#include <iostream>
#include <iomanip>
#include <sqlplus.hh>

#define DATABASE "search_engine"
#define HOST "velu.essi.fr"
#define USER "se_user"
#define PASSWORD "moteur_pass"


class ConnectBase
{
public:

  ConnectBase() : con(DATABASE,HOST,USER,PASSWORD), query(con.query())
  {}
 
  ConnectBase(const char *db,const char *h,const char* u,const char* p) : con(db, h, u, p), query( con.query() ) 
   {} 

  bool dejaVu(string &url);

  void ajoutMauvaisUrl(string &url);

  void executeSelect(string &req);

  void executeQuery(string &req);

  string donneUrl();

  int nbEntrees();

private:

  Connection con;
  Query query;
  Result res;
  Result::iterator rowIterator;

};
//c++  -I/u/org/bds/sengine/mysql++-1.7.9/sqlplusint -I/u/org/bds/sengine/mysql-3.23.49a-pc-linux-gnu-i686/include -g -c connectbase.cc 

//c++ -L/u/org/bds/sengine/mysql-3.23.49a-pc-linux-gnu-i686/lib -o testbac testbac.o /u/org/bds/sengine/mysql++-1.7.9/sqlplusint/.libs/libsqlplus.so -L/u/org/bds/sengine/mysql-3.23.49a-pc-linux-gnu-i686/include -lz -lmysqlclient -lz -lmysqlclient -Wl,--rpath -Wl,/usr/local/libc
