#ifndef _FILECONFIG_H


#include <string>
#include <map>
#include <list>
#include <strstream>
#include <stdio.h>
#include <iostream>
#include <fstream>

class FileConfig{
 public:
  FileConfig(char* file){
    char * themetxt =getInfo(file);
    if (themetxt!="")
      createTheme(themetxt);
  }
  
  int getTime(){
    return time;
  };
  
  int getDeep(){
    return deep;
  };
  
  string getDomaine(){
    return domaine;
  };

  list<string> getType(){
    return type;
  };
  
  map<string,unsigned> getTheme(){
    return theme;
  };


 private:

  void createTheme(char* fichier);
  char * getInfo(char * fichier);
  
  int time;
  int deep;
  string domaine;
  list<string> type;
  map<string,unsigned> theme;
};
#endif
