/***************************************************************************
                          indexing.cpp  -  description
                             -------------------
    begin                : Wed May 22 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#include <string>
#include <strstream>

#include "indexing.h"

ConnectBase Indexing::dataBase;

Indexing::Indexing() {
}


Indexing::~Indexing() {
}


void Indexing::index( const char * fileName, const char * extFile, const string & text, unsigned int & nbWordInTheme, Contraintes & contraint ) {
//	cout << "INDEXATION: " << fileName << endl;
	string req = "INSERT IGNORE INTO Extension ( extension ) VALUES (" + ConnectBase::formatString( extFile ) + ")";
	try { dataBase.executeQuery( req ); } catch(...) { cout << "EXCEPTION extension " << extFile << endl; }
	
//	req = "INSERT IGNORE INTO Url (url, idExt, derniereVisite) SELECT " + ConnectBase::formatString( fileName ) + ", idExt, NOW() FROM Extension WHERE extension = " + ConnectBase::formatString( extFile );
//	dataBase.executeQuery( req );	
	
	istrstream flux ( text.c_str(), text.length() );
	
	string mot;
	flux >> mot;
	while( flux.good() ) {
		listKeyWords[ lowerCase( mot ) ].frequence += 1;
		flux >> mot;
	}
	
	nbWordInTheme = 0;
	bool indexing = false;
	bool indexingNecessary=true;
/*	for( Dictionary::iterator i = listKeyWords.begin(); i != listKeyWords.end(); ++i ) {
		int freq = contraint.wordValue( i->first );
		if(  freq <= i->second.frequence && freq >= 0 ) {
			indexing = true;
			break;
		}
   }*/
	for( Contraintes::ConstraintWord::iterator i = contraint.theme.begin(); i != contraint.theme.end(); ++i ) {
		if( i->second > 0 ) {
			Dictionary::iterator j = listKeyWords.find( i->first );
			if( j != listKeyWords.end() ) {
				if(  i->second <= j->second.frequence && i->second >= 0 ) {
					indexing =true;
				}
			}
		}
		else if( i->second == 0 ) {
			Dictionary::iterator j = listKeyWords.find( i->first );
			if( j != listKeyWords.end() )  {
				indexingNecessary = true;
			}
			else {
				indexingNecessary = false;
				break;			
			}			
		}
   }

	if( indexing&&indexingNecessary )
  	for( Dictionary::iterator i = listKeyWords.begin(); i != listKeyWords.end(); ++i ) {
		int freq = contraint.wordValue( i->first );
		if( freq > 0 )
			++nbWordInTheme;

		if( i->first.length() > 1 && freq >= 0 ) {
			req = "INSERT IGNORE INTO MotCle ( Mot ) VALUES (" + ConnectBase::formatString( i->first ) + ")";
  			try { dataBase.executeQuery( req ); } catch(...) { cout << "EXCEPTION MotCle " << i->first << endl; }
	  		ostrstream os;
	  		os << "INSERT INTO CorrespMotUrl ( idMot, idUrl, ratio ) SELECT idMot, idUrl, '" << i->second.frequence
	  		     << "' FROM MotCle, Url WHERE mot = " << ConnectBase::formatString( i->first )
	  		     << " AND url = " << ConnectBase::formatString( fileName ) << ends;
	  		req = os.str();
	  		try { dataBase.executeQuery( req ); } catch(...) { cout << "EXCEPTION CorrespMotUrl" << i->first << " " << fileName << " " << i->second.frequence << endl << req << endl; }
	  	}
  	}

	ostrstream os;
	os << "UPDATE Url SET nbMotsTheme = " << nbWordInTheme << " WHERE url = " << ConnectBase::formatString( fileName ) << " LIMIT 1" << ends;
	req = os.str();
	dataBase.executeQuery( req );	
  	
	listKeyWords.clear();
}


string & Indexing::lowerCase( string & word ) {
	for( unsigned i = 0; i < word.length(); ++i ) {
		if( word[i] >= 'A' && word[i] <='Z' )
			word[i] = word[i] - 'A' + 'a';
	}
	return word;
}
