/***************************************************************************
                          mutex.cpp  -  description
                             -------------------
    begin                : Fri May 24 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#include "mutex.h"


Mutex::Mutex( unsigned nb = 1 ) {
	sem_init( &semaphore, 0, nb );	
}


Mutex::~Mutex() {
	sem_destroy( &semaphore );
}


void Mutex::P() {
	sem_wait( &semaphore );
}


void Mutex::V() {
	sem_post( &semaphore );
}


int Mutex::getVal() {
	int val;
	sem_getvalue( &semaphore, &val);
	return val;
}
