/***************************************************************************
                          parsehtml.h  -  description
                             -------------------
    begin                : Fri May 24 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#ifndef _PARSEHTML_H_
#define _PARSEHTML_H_

#include <FlexLexer.h>
#include <string>
#include <vector>


class ParseHTML : protected yyFlexLexer {
private:
	virtual int yylex();

	vector<string> vectLink;
   vector<string> vectImg;
   string text;

protected:
	void ParseHTML::insertLien() ;
	void ParseHTML::insertImage();
	void ParseHTML::insertmot(const char * mot) ;
	void ParseHTML::insertmot() ;

public:
	ParseHTML( const string & text );

	const vector<string> & getLiens() const;
	const vector<string> & getImages() const;
	const string & getMots() const;

};

#endif
