/*
partie arrire du spider
*/

#ifndef _TRAITEDOC_H
#define _TRAITEDOC_H

#include <vector>
#include <string>
#include <iostream>
#include <stdio.h>
#include <strstream>
#include "parsehtml.h"
#include "indexing.h"
#include "contraintes.h"


class TraiteDoc{
 public:

  //le constructeur
  TraiteDoc(  string & urlFic, string & texte);
  TraiteDoc(  string & urlFic, string & texte,Contraintes  &con);
  // sendText(String & texte, String & NameFic, String & racineFic);

  //renvoie tous les liens de la page
  vector<string> &getLink();

//int getOccurence()

  //renvoie le nombre de mot du texte qui sont prsent dans le thme
  unsigned int wordInTheme();
  
  //recupere le type du document  "xxx.html" -> "html"
  void decomposeURL(string & url );
  
  void infoType();
  
  string liftingLien(string url);

  //corrections des liens recuperer par lex
  void correctionLiens();

  //traite le document en fonction du type
  bool traiterPage();

  void addLien(string & li){
    lien.push_back(li);
  }
  
  void showLien(){  
    int taille=lien.size();
    for(int i=0;i<taille;i++){
      cout <<lien[i]<<"&&"<<endl;
    }
  }
	
	string & lowerCase( string & word ) {
			for( unsigned int i = 0; i < word.length(); i++ ) {
				if( word[i] >= 'A' && word[i] <='Z' )
					word[i] = word[i] - 'A' + 'a';
			}
		return word;	
	}
	
 private:
  string & text;//la page  traiter
  unsigned int nbMotTheme;////le nombre de mots du thme prsents dans la page
  string urlFile; 
  bool redirection;//si il y a une redirection d  une page 302
  string cheminFic;//chemin o se trouve la page
  string extFic;//extension du fichier
  vector<string> lien;//les liens trouver dans la page
  Contraintes contrainte;
   Indexing index;
};

#endif
